
---------------------------------------------------------------------------------
--
-- Update and Insert the FCM_ALERT_TYPE Table for the correct Alertable Field 
-- and Add the Trade Id as an Alertable Entity  Alert Value "T"
--
---------------------------------------------------------------------------------
update fcm_alert_type set key_field_id = (select field_id from fcm_field_definition where field_name = 'aqo_acct_num') where alert_type = 'A';
update fcm_alert_type set key_field_id = (select field_id from fcm_field_definition where field_name = 'xqo_cust_num') where alert_type = 'X';
update fcm_alert_type set key_field_id = (select field_id from fcm_field_definition where field_name = 'hqo_card_num') where alert_type = 'C';
update fcm_alert_type set key_field_id = (select field_id from fcm_field_definition where field_name = 'hqo_ob_userid') where alert_type = 'O';
update fcm_alert_type set key_field_id = (select field_id from fcm_field_definition where field_name = 'hqo_pb_userid') where alert_type = 'P';
update fcm_alert_type set key_field_id = (select field_id from fcm_field_definition where field_name = 'tbt_ref_num') where alert_type = 'W';
update fcm_alert_type set key_field_id = (select field_id from fcm_field_definition where field_name = 'taq_batch_id') where alert_type = 'H';

MERGE into FCM_ALERT_TYPE
USING TABLE(values('T'))
                     ac(ALERT_TYPE) 
                  ON (FCM_ALERT_TYPE.ALERT_TYPE = ac.ALERT_TYPE)
when not matched then
insert (
	ALERT_TYPE, KEY_FIELD_ID, ALERT_TYPE_NAME, 
	ALERT_TYPE_SHORT_NAME, ALERT_TYPE_DESC, 
	CREATE_TIMESTAMP, CREATE_USER, LSTUPDT_USER, 
	LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, 
	LOCAL_DEMO_ALERT_TYPE) 
VALUES (
 'T' 
 , (select field_id from fcm_field_definition where field_name = 'tst_unq_trade_id')
 , 'TRADE'
 , 'TRADE'        
 , 'Trade ID'
 ,  current timestamp - current timezone
 ,  CURRENT USER  
 ,  CURRENT USER  
 ,  current timestamp - current timezone
 , 0
 , '0'
 , 'X'
   )
when  matched then
 update
 	set KEY_FIELD_ID = (select field_id from fcm_field_definition where field_name = 'tst_unq_trade_id')
ELSE IGNORE;


---------------------------------------------------------------------------------
--
-- Update FCM_PROPERTY for GWIM highlighting changes
--
---------------------------------------------------------------------------------
insert into FCM_PROPERTY (property_type, property_label, property_name, property_value, property_desc, property_editable_ind, property_sub_type, property_sub_type_label,
                          create_timestamp, lstupdt_timestamp, create_user, lstupdt_user, lstupdt_nbr, logical_del_ind) 
values
('RuleTesting','Initial Rows per Page','rule_initial_rows_per_page','20','Initial number of rows that will be displayed per page for pageable tables in Rule Testing and Estimation.','1','DEFAULT','DEFAULT',
  CURRENT TIMESTAMP, CURRENT TIMESTAMP, CURRENT USER, CURRENT USER, 1, '0'),
('RuleTesting','Highlight Results Columns','highlight_results_columns','aqo_acct_num rqo_tran_date rqo_tran_time','Columns displayed for highlighted transactions in the results of Rule Testing and Estimation.','1','DEFAULT','DEFAULT',
  CURRENT TIMESTAMP, CURRENT TIMESTAMP, CURRENT USER, CURRENT USER, 1, '0'),
('AGS','Validate XML','ags_validate_xml','FALSE','Specifies if XML documents that are created are validated before sending.  Validation slows down the system.','1','DEFAULT','DEFAULT',
  CURRENT TIMESTAMP, CURRENT TIMESTAMP, CURRENT USER, CURRENT USER, 1, '0'),
('AGS','Max highlights from expressions','ags_max_highlights_from_expressions','10000','Specifies total number of values for highlights/links reconciliation on all highlights.','1','DEFAULT','DEFAULT',
  CURRENT TIMESTAMP, CURRENT TIMESTAMP, CURRENT USER, CURRENT USER, 1, '0'),
('AGS','Max seconds wait for idle','ags_highlights_max_wait_for_idle_seconds','60','Specifies total time in seconds to wait for system to become idle before beginning highlight reconciliation. ','1','DEFAULT','DEFAULT',
  CURRENT TIMESTAMP, CURRENT TIMESTAMP, CURRENT USER, CURRENT USER, 1, '0'),
('AGS','Max seconds check for idle','ags_highlights_check_idle_time_seconds','6','Specifies time in seconds between checks for system idle before beginning highlight reconcillation','1','DEFAULT','DEFAULT',
  CURRENT TIMESTAMP, CURRENT TIMESTAMP, CURRENT USER, CURRENT USER, 1, '0'),
('AGS','Highlight resolution complete command','ags_highlights_resolve_complete_cmd','','Specifies program or shell script to be called with highlight resolution is complete.','1','DEFAULT','DEFAULT',
  CURRENT TIMESTAMP, CURRENT TIMESTAMP, CURRENT USER, CURRENT USER, 1, '0'),
('AGS','Enable Note XML declaration','ags_add_notes_xml_declaration','FALSE','Specifies if the XML declaration should be added to the Notes XML document','1','DEFAULT','DEFAULT',
  CURRENT TIMESTAMP, CURRENT TIMESTAMP, CURRENT USER, CURRENT USER, 1, '0'),
('AGS','Maximum Highlight Expression Length','max_highlight_expression_length','2000','The maximum length of the expression used to highlight or link to transactions','1','DEFAULT','DEFAULT',
  CURRENT TIMESTAMP, CURRENT TIMESTAMP, CURRENT USER, CURRENT USER, 1, '0'),
('AGS','Maximum Highlights or Links per Rule','max_highlights_per_rule','100','The maximum number of highlights and links that may be produced directly (not from a WHERE expression) by a single rule','1','DEFAULT','DEFAULT',
  CURRENT TIMESTAMP, CURRENT TIMESTAMP, CURRENT USER, CURRENT USER, 1, '0'),
('AGS','Maximum Notes per Rule','max_notes_per_rule','100','The maximum number of notes that may be produced by a single rule','1','DEFAULT','DEFAULT',
  CURRENT TIMESTAMP, CURRENT TIMESTAMP, CURRENT USER, CURRENT USER, 1, '0'),
('AGS','Maximum Note Text Length','max_note_text_length','200','The maximum length of the text of a note','1','DEFAULT','DEFAULT',
  CURRENT TIMESTAMP, CURRENT TIMESTAMP, CURRENT USER, CURRENT USER, 1, '0');






---------------------------------------------------------------------------------
--
-- Update FCM_ACTION for GWIM highlighting changes
--
---------------------------------------------------------------------------------
delete from FCM_ACTION where action_id in (50163,50164,50165);

insert into FCM_ACTION (action_id, action_type, action_name, action_desc, action_code, action_sort_order, rule_type_id, alert_type,
                        create_timestamp, lstupdt_timestamp, create_user, lstupdt_user, lstupdt_nbr, logical_del_ind)
values
(50182,'QUE','Add a highlight and optional link to a transaction','Add a highlight and optional link to a transaction','%Action_Highlight(<highlightedTranID>,<linkedTranID>);',3,203,'T',
  CURRENT TIMESTAMP, CURRENT TIMESTAMP, CURRENT USER, CURRENT USER, 1, '0'),
(50183,'QUE','Add highlights/links based on an expression','Add highlights/links based on an expression','%Action_Highlight_Where(highlight_id=<tranID>,highlight_where=<expression>,link_id=<tranID>,link_where=<expression>);',3,203,'T',
  CURRENT TIMESTAMP, CURRENT TIMESTAMP, CURRENT USER, CURRENT USER, 1, '0'),
(50184,'QUE','Add a note to a transaction','Add a note to a transaction','%Action_Note(<tranID>,<text>);',3,203,'T',
  CURRENT TIMESTAMP, CURRENT TIMESTAMP, CURRENT USER, CURRENT USER, 1, '0');




---------------------------------------------------------------------------------
--
-- Insert version release 3.2.2.3 (3.2 M2 HF3)
--
---------------------------------------------------------------------------------

insert into fcm_version(VERSION_NAME , VERSION_NUM , VERSION_DATE , VERSION_DESC, VERSION_COMPONENT) VALUES
('Base DDL', '3.2.2.3', current date, '3.2 M2 HF3 DDL', 'DDL');